Unit IS03R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, II21R1_p, ASB1R_p, UTIS10_p;

procedure IS03R(N :Integer; K :Integer; LX :Integer;
                var T :Array of Real; var X :Array of Real;
                var G :Array of Real; var W :Array of Real;
                var A :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var IERR :Integer);

implementation

procedure IS03R(N :Integer; K :Integer; LX :Integer;
                var T :Array of Real; var X :Array of Real;
                var G :Array of Real; var W :Array of Real;
                var A :Array of Real; var R :Array of Real;
                var R1 :Array of Real; var R2 :Array of Real;
                var IERR :Integer);
var
I,NM1,KM1,J,ILEFT,IMK,L,JJ,M,KM2 :Integer;
GL,DW,WL :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
{ *    OPOPAMMA HAXOT CPEHEKBAPATECKY             *C }
{ *    APOKCMA B-CAHAM }
IERR := 0;
KM1 := K-1;
KM2 := K+KM1;
for I:=1 to N do
 begin
  A[I-1] := ZERO;
  for J:=1 to KM2 do
   begin
_1:
    R[(I-1)+(J-1)*N] := ZERO;
   end;
_2:
 end;
ILEFT := K;
IMK := 0;
for L:=1 to LX do
 begin
_3:
  if ( ILEFT = N ) 
   then goto _4;
  if ( X[L-1] < T[ILEFT+0] ) 
   then goto _4;
  ILEFT := ILEFT+1;
  IMK := ILEFT-K;
  goto _3;
_4:
  II21R1(T,K,X[L-1],ILEFT,R1,R2);
  WL := W[L-1];
  GL := G[L-1];
  for JJ:=1 to K do
   begin
    DW := R1[JJ-1]*WL;
    I := IMK+JJ;
    A[I-1] := DW*GL+A[I-1];
    J := K;
    for M:=JJ to K do
     begin
      R[(I-1)+(J-1)*N] := DW*R1[M-1]+R[(I-1)+(J-1)*N];
_5:
      J := J+1;
     end;
_6:
   end;
_7:
 end;
NM1 := N-1;
for I:=1 to NM1 do
 begin
  for J:=1 to KM1 do
   begin
    L := I+J;
    M := K-J;
    JJ := K+J;
    if ( L > N ) 
     then goto _9;
    R[(L-1)+(M-1)*N] := R[(I-1)+(JJ-1)*N];
_8:
   end;
_9:
 end;
ASB1R(R,A,A,N,KM1,KM1,1,R2,IERR);
if ( IERR <> 0 ) 
 then goto _10;
goto _11;
_10:
IERR := 65;
UTIS10(IERR,3);
_11:
end;

end.
